<template>
  <i-wrapper top>
    <i-header :title="$t(`astrologerTitles.${report.type}`)" :back="{ name: 'astrologers' }" />
    <i-curtain :bottom-circles="false" scrollable fixed bottom-fixed>
      <div class="p-title">
        <img src="~assets/images/astrologers-natal-chart.svg" class="p-title__image" />
        {{ $t(`astrologerTitles.${report.type}`) }}
      </div>
      <div class="p-by">
        <img src="~assets/images/scientist-circle.png" class="p-by__image" />
        by Human astrologies & AI
      </div>
      <div class="p-points">
        <div class="p-point">
          <div class="p-point__title">Time of reply</div>
          <div class="p-point__description">up to 3-4 days</div>
        </div>
        <div class="p-points__separator" />
        <div class="p-point">
          <div class="p-point__title">Answer length</div>
          <div class="p-point__description">up to 5-20 pages</div>
        </div>
      </div>
      <div class="container">
        <div class="p-header">How it works?</div>
        <div class="p-steps">
          <div class="p-step">
            <div class="p-step__number">1.</div>
            Choose the report
          </div>
          <div class="p-step">
            <div class="p-step__number">2.</div>
            Wait up to 5 days
          </div>
          <div class="p-step">
            <div class="p-step__number">3.</div>
            Get an answer in the app
          </div>
        </div>
        <div class="p-header">Description:</div>
        <div class="p-description">
          {{ $t(`astrologerFullDescriptions.${report.type}`) }}
        </div>
        <div class="p-information">
          <img src="~assets/images/astrologers-information-question.svg" class="p-information__image" />
          We provide the reports in English
        </div>
        <div class="p-header">What you get:</div>
        <div class="p-details">
          <div v-for="reportDetail in reportDetails" :key="reportDetail.title" class="p-detail">
            <div class="p-detail__header">
              <img src="~assets/images/astrologers-report-detail.svg" class="p-detail__image" />
              {{ reportDetail.title }}
            </div>
            <div class="p-detail__description">{{ reportDetail.description }}</div>
          </div>
        </div>
      </div>
      <template #bottom>
        <div class="p-buttons">
          <i-button block @click="order()" :disabled="hasReportOrdered">
            {{ hasReportOrdered ? 'ORDERED' : 'ORDER' }}
          </i-button>
          <i-button white :icon="require('~/assets/images/button-eye.svg')" @click="preview()" />
        </div>
      </template>
    </i-curtain>
  </i-wrapper>
</template>

<script>
  import { mapState } from 'vuex';

  export default {
    layout: 'default',
    nuxtI18n: false,
    middleware: ['logged-in-only'],
    transition: { name: 'fade', mode: 'out-in' },

    async asyncData({ $axios, params, redirect }) {
      if (!['natal-chart', 'synastry-report', 'transit-report'].includes(params.reportType)) {
        return redirect({ name: 'astrologers' });
      }

      let response = await $axios.get(`users/me/reports/${params.reportType}/price`);

      return {
        report: {
          type: params.reportType,
          stripePrice: response.data.data,
        },
      };
    },

    data() {
      return {
        stripe: null,
        canMakePayment: null,
        paymentRequest: null,
        isMounted: false,
        isLoading: false,
      };
    },

    computed: {
      ...mapState(['auth']),

      status() {
        return this.$route.query.rr || null;
      },

      userReports() {
        let data = {};

        ['natal-chart', 'synastry-report', 'transit-report'].forEach((reportType) => {
          data[reportType] = this.auth.user.reports.find((report) => report.type === reportType) || null;
        });

        return data;
      },

      hasReportOrdered() {
        return !!this.userReports[this.report.type];
      },

      reportDetails() {
        let benefits = ['first', 'second', 'third', 'fourth', 'fifth', 'sixth'].map((benefitId) => {
          return {
            title: this.$t(`astrologerBenefitTitles.${benefitId}`),
            description: this.$t(`astrologerenefitDescriptions.${benefitId}`),
          };
        });

        if (this.report.type === 'natal-chart') {
          return [0, 1, 2, 3].map((index) => benefits[index]);
        }

        if (this.report.type === 'synastry-report') {
          return [4, 2, 3, 0].map((index) => benefits[index]);
        }

        if (this.report.type === 'transit-report') {
          return [5, 1, 2, 3].map((index) => benefits[index]);
        }

        return [];
      },
    },

    async mounted() {
      this.isMounted = true;

      if (this.userReports[this.report.type]) {
        return;
      }

      if (this.status === 'success') {
        return this.validate();
      }

      if (this.status) {
        alert('Something went wrong. Please, try again.');
      }

      this.stripe = Stripe(this.auth.stripe.publicKey);

      this.paymentRequest = this.stripe.paymentRequest({
        country: 'CY',
        currency: this.report.stripePrice.currency.toLowerCase(),
        total: {
          label: 'Total',
          amount: this.report.stripePrice.amount * 100,
        },
        requestPayerName: true,
        requestPayerEmail: true,
      });

      this.paymentRequest.on('paymentmethod', async (event) => {
        this.paymentMethod = event.paymentMethod;

        let response = await this.$axios.post(`users/me/reports/${this.report.type}/create`, {
          stripePaymentMethodId: this.paymentMethod.id,
        });

        event.complete('success');

        if (response.data.data.reports) {
          this.$store.commit('MERGE_AUTH', {
            user: { reports: response.data.data.reports },
          });
        }

        setTimeout(() => {
          if (response.data.data.hasBeenOrdered) {
            alert('The report has been ordered!');
          } else if (this.hasReportOrdered) {
            alert('You already subscribed.');
          } else {
            alert('Something went wrong. Please, try again.');
          }
        }, 1000);
      });

      this.canMakePayment = !!(await this.paymentRequest.canMakePayment());
    },

    methods: {
      async validate() {
        try {
          let response = await this.$axios.post(`users/me/reports/${this.report.type}/validate`, {
            stripeCheckoutSessionId: this.$route.query.scsi,
          });

          if (!response.data.data.reports.find((report) => report.type === this.report.type)) {
            setTimeout(this.validate, 2500);
            return;
          }

          this.$store.commit('MERGE_AUTH', { user: response.data.data });
          alert('The report has been ordered!');

          setTimeout(() => {
            this.$router.replace({ name: this.$route.name, params: this.$route.params, query: {} });
          }, 250);
        } catch (error) {
          console.error(error);
          setTimeout(this.validate, 2500);
        }
      },

      async order() {
        if (this.canMakePayment) {
          this.paymentRequest.show();
          return;
        }

        this.isLoading = true;

        try {
          let response = await this.$axios.post(`users/me/reports/${this.report.type}/initiate`, {
            cancelUrl: window.location.origin + this.$route.path + '?rr=cancel',
            successUrl: window.location.origin + this.$route.path + '?rr=success&scsi=CHECKOUT_SESSION_ID',
          });

          if (response.data.data.isBought) {
            alert('The report has been already ordered.');

            this.$store.commit('MERGE_AUTH', {
              user: { reports: response.data.data.reports },
            });

            return;
          }

          window.location.href = response.data.data.checkoutUrl;
        } catch (error) {
          this.isLoading = false;
          throw error;
        }
      },

      preview() {
        this.$router.push({ name: 'astrologers.reportType.sample', params: { reportType: this.report.type } });
      },
    },
  };
</script>

<style lang="scss" scoped>
  .p-title {
    display: flex;
    align-items: center;
    justify-content: center;
    font-size: rf(20px);
    font-weight: bold;
    color: #524c62;
    margin-top: rs(30px);
  }

  .p-title__image {
    width: rs(30px);
    height: rs(30px);
    margin-right: rs(15px);
  }

  .p-by {
    display: flex;
    align-items: center;
    justify-content: center;
    font-size: rf(20px);
    color: #524c62;
    margin-top: rs(18px);
  }

  .p-by__image {
    width: rs(33px);
    height: rs(31px);
    margin-right: rs(5px);
  }

  .p-points {
    display: flex;
    align-items: center;
    width: 100%;
    margin-top: rs(32px);
    margin-bottom: rs(12px);
  }

  .p-points__separator {
    width: rs(1px);
    height: rs(33px);
    background-color: #fb7474;
  }

  .p-point {
    display: flex;
    flex-direction: column;
    align-items: center;
    justify-content: center;
    flex-basis: 50%;
  }

  .p-point__title {
    font-size: rf(14px);
    color: #444757;
  }

  .p-point__description {
    font-size: rf(14px);
    color: #444757;
    font-weight: bold;
    margin-top: rs(10px);
  }

  .p-header {
    width: 100%;
    font-size: rf(16px);
    color: #fa7d70;
    font-weight: bold;
    margin-bottom: rs(10px);
  }

  .p-steps {
    width: 100%;
    margin-bottom: rs(20px);
  }

  .p-step {
    display: flex;
    align-items: center;
    font-size: rf(14px);
    color: #444757;

    &:not(:first-child) {
      margin-top: rs(10px);
    }
  }

  .p-step__number {
    display: flex;
    align-items: center;
    justify-content: center;
    width: rs(24px);
    height: rs(24px);
    border-radius: rs(12px);
    font-size: rf(12px);
    color: #fa7d70;
    font-weight: bold;
    background-color: #fff2f1;
    margin-right: rs(10px);
  }

  .p-description {
    font-size: rf(16px);
    color: #444757;
    line-height: 140%;
    margin-bottom: rs(15px);
  }

  .p-information {
    position: relative;
    display: flex;
    align-items: center;
    justify-content: flex-start;
    width: 100%;
    height: rs(53px);
    background-color: #fff1f1;
    border-radius: rs(10px);
    color: #fb7474;
    margin-bottom: rs(20px);
  }

  .p-information__image {
    width: rs(33px);
    height: rs(33px);
    margin-left: rs(19px);
    margin-right: rs(13px);
  }

  .p-details {
    //
  }

  .p-detail {
    display: flex;
    flex-direction: column;
    padding: rs(15px);
    background-color: rgba(#f5f5f5, 50%);
    border-radius: rs(10px);

    &:not(:first-child) {
      margin-top: rs(15px);
    }
  }

  .p-detail__header {
    display: flex;
    align-items: center;
    font-size: rf(14px);
    color: #444757;
    font-weight: bold;
  }

  .p-detail__image {
    width: rs(12px);
    height: rs(12px);
    margin-right: rs(10px);
  }

  .p-detail__description {
    font-size: rf(14px);
    color: #444757;
    line-height: 140%;
    margin-top: rs(5px);
  }

  .p-buttons {
    display: flex;
    align-items: center;
    width: 100%;
  }

  .p-buttons .i-button:not(:first-child) {
    margin-left: rs(15px);
  }
</style>
